searchData={"items":[{"type":"module","title":"AI","doc":"AI is a behavior module that defines the interface for interacting with\nOpenAI's API. It provides a common interface for the various OpenAI-powered\noperations used by the application.","ref":"AI.html"},{"type":"function","title":"AI.get_completion/4","doc":"","ref":"AI.html#get_completion/4"},{"type":"function","title":"AI.get_embeddings/2","doc":"Get embeddings for the given text. The text is split into chunks of 8192\ntokens to avoid exceeding the model's input limit. Returns a list of\nembeddings for each chunk.","ref":"AI.html#get_embeddings/2"},{"type":"function","title":"AI.new/0","doc":"Create a new AI instance. Instances share the same client connection.","ref":"AI.html#new/0"},{"type":"type","title":"AI.t/0","doc":"","ref":"AI.html#t:t/0"},{"type":"module","title":"AI.Accumulator","doc":"When file or other input to too large for the model's context window, this\nmodule may be used to process the file in chunks. It automatically modifies\nthe supplied agent prompt to include instructions for accumulating a response\nacross multiple chunks based on the `max_tokens` parameter supplied to the\n`get_response` function.\n\nNote that while this makes use of the `AI.Completion` module, it does NOT\nhave the same interface and cannot be used for long-running conversations, as\nit does not accept a list of messages as its input.","ref":"AI.Accumulator.html"},{"type":"function","title":"AI.Accumulator.get_response/2","doc":"","ref":"AI.Accumulator.html#get_response/2"},{"type":"type","title":"AI.Accumulator.error/0","doc":"","ref":"AI.Accumulator.html#t:error/0"},{"type":"type","title":"AI.Accumulator.response/0","doc":"","ref":"AI.Accumulator.html#t:response/0"},{"type":"type","title":"AI.Accumulator.success/0","doc":"","ref":"AI.Accumulator.html#t:success/0"},{"type":"behaviour","title":"AI.Agent","doc":"","ref":"AI.Agent.html"},{"type":"callback","title":"AI.Agent.get_response/2","doc":"","ref":"AI.Agent.html#c:get_response/2"},{"type":"type","title":"AI.Agent.error/0","doc":"","ref":"AI.Agent.html#t:error/0"},{"type":"type","title":"AI.Agent.response/0","doc":"","ref":"AI.Agent.html#t:response/0"},{"type":"module","title":"AI.Agent.Answers","doc":"","ref":"AI.Agent.Answers.html"},{"type":"module","title":"AI.Agent.CodeMapper","doc":"","ref":"AI.Agent.CodeMapper.html"},{"type":"module","title":"AI.Agent.FileInfo","doc":"","ref":"AI.Agent.FileInfo.html"},{"type":"module","title":"AI.Agent.FileSummary","doc":"This module provides an agent that summarizes files' contents in order to\ngenerate embeddings for the database and summaries for the user.","ref":"AI.Agent.FileSummary.html"},{"type":"module","title":"AI.Agent.NotesConsolidator","doc":"","ref":"AI.Agent.NotesConsolidator.html"},{"type":"module","title":"AI.Agent.Planner","doc":"","ref":"AI.Agent.Planner.html"},{"type":"module","title":"AI.Agent.Spelunker","doc":"","ref":"AI.Agent.Spelunker.html"},{"type":"module","title":"AI.Completion","doc":"This module sends a request to the model and handles the response. It is able\nto handle tool calls and responses. If the caller includes an `on_event`\nfunction, it will be called whenever a tool call is performed or if a tool\ncall results in an error.","ref":"AI.Completion.html"},{"type":"function","title":"AI.Completion.context_window_usage/1","doc":"","ref":"AI.Completion.html#context_window_usage/1"},{"type":"function","title":"AI.Completion.get/2","doc":"","ref":"AI.Completion.html#get/2"},{"type":"function","title":"AI.Completion.get_completion/1","doc":"","ref":"AI.Completion.html#get_completion/1"},{"type":"function","title":"AI.Completion.handle_tool_call/2","doc":"","ref":"AI.Completion.html#handle_tool_call/2"},{"type":"type","title":"AI.Completion.error/0","doc":"","ref":"AI.Completion.html#t:error/0"},{"type":"type","title":"AI.Completion.response/0","doc":"","ref":"AI.Completion.html#t:response/0"},{"type":"type","title":"AI.Completion.success/0","doc":"","ref":"AI.Completion.html#t:success/0"},{"type":"type","title":"AI.Completion.t/0","doc":"","ref":"AI.Completion.html#t:t/0"},{"type":"module","title":"AI.OpenAI","doc":"This module provides functions to interact with the OpenAI API, including\ngetting embeddings and completions.","ref":"AI.OpenAI.html"},{"type":"function","title":"AI.OpenAI.get_completion/4","doc":"","ref":"AI.OpenAI.html#get_completion/4"},{"type":"function","title":"AI.OpenAI.get_embedding/3","doc":"","ref":"AI.OpenAI.html#get_embedding/3"},{"type":"function","title":"AI.OpenAI.new/1","doc":"","ref":"AI.OpenAI.html#new/1"},{"type":"module","title":"AI.Splitter","doc":"This module is used to split a string into chunks by the number of tokens,\nwhile accounting for *other* data that might be going with it to the API\nendpoint with the limited token count.\n\nFor example, the search entry agent may be processing a large file, one that\nmust be split into 3 slices just to fit it into the payload of an API call.\nIn order to retain context between chunks, the agent essentially _reduces_\nover the file, keeping track of information in the previous chunks to\ngenerate a final summary. Doing that means that we need to not only split the\nfile by the number of tokens in each slice, but also keep some space for the\nbespoke data that will be added to the payload as the agent's \"accumulator\".","ref":"AI.Splitter.html"},{"type":"function","title":"AI.Splitter.new/3","doc":"","ref":"AI.Splitter.html#new/3"},{"type":"function","title":"AI.Splitter.next_chunk/2","doc":"","ref":"AI.Splitter.html#next_chunk/2"},{"type":"behaviour","title":"AI.Tokenizer","doc":"> Oh yeah? I'm gonna make my own tokenizer, with blackjack and hookers!\n                                                    -- ~Bender~ ChatGPT\n\nThe only tokenizer modules available for elixir when this was written are\neither older and don't correctly count for OpenAI's newer models\n(Gpt3Tokenizer) or can't be used in an escript because they require priv\naccess or OTP support beyond escript's abilities (Tokenizers).","ref":"AI.Tokenizer.html"},{"type":"function","title":"AI.Tokenizer.chunk/3","doc":"Splits a string into chunks of `max_tokens` tokens using the algorithm\ndefined for the specified model.","ref":"AI.Tokenizer.html#chunk/3"},{"type":"function","title":"AI.Tokenizer.decode/2","doc":"Decodes a list of token IDs into a text string using the algorithm defined\nfor the specified model.","ref":"AI.Tokenizer.html#decode/2"},{"type":"callback","title":"AI.Tokenizer.decode/2","doc":"","ref":"AI.Tokenizer.html#c:decode/2"},{"type":"function","title":"AI.Tokenizer.encode/2","doc":"Encodes a text string into a list of token IDs using the algorithm defined\nfor the specified model.","ref":"AI.Tokenizer.html#encode/2"},{"type":"callback","title":"AI.Tokenizer.encode/2","doc":"","ref":"AI.Tokenizer.html#c:encode/2"},{"type":"function","title":"AI.Tokenizer.get_impl/0","doc":"Returns the tokenizer implementation module currently in use. This is defined\nin the application config, under `fnord/tokenizer_module`, allowing it to be\noverridden for testing.","ref":"AI.Tokenizer.html#get_impl/0"},{"type":"module","title":"AI.Tokenizer.Default","doc":"Implements the default tokenizer behaviour for AI.Tokenizer.","ref":"AI.Tokenizer.Default.html"},{"type":"module","title":"AI.Tokenizer.Tokens_cl100k_base","doc":"This module implements the cl100k-base tokenizer model used by OpenAI's\n`text-embedding-3-large` model.","ref":"AI.Tokenizer.Tokens_cl100k_base.html"},{"type":"function","title":"AI.Tokenizer.Tokens_cl100k_base.get_merges/0","doc":"","ref":"AI.Tokenizer.Tokens_cl100k_base.html#get_merges/0"},{"type":"function","title":"AI.Tokenizer.Tokens_cl100k_base.get_pattern/0","doc":"","ref":"AI.Tokenizer.Tokens_cl100k_base.html#get_pattern/0"},{"type":"function","title":"AI.Tokenizer.Tokens_cl100k_base.get_reverse_vocab/0","doc":"","ref":"AI.Tokenizer.Tokens_cl100k_base.html#get_reverse_vocab/0"},{"type":"function","title":"AI.Tokenizer.Tokens_cl100k_base.get_special_tokens/0","doc":"","ref":"AI.Tokenizer.Tokens_cl100k_base.html#get_special_tokens/0"},{"type":"function","title":"AI.Tokenizer.Tokens_cl100k_base.get_vocab/0","doc":"","ref":"AI.Tokenizer.Tokens_cl100k_base.html#get_vocab/0"},{"type":"module","title":"AI.Tokenizer.Tokens_o200k_base","doc":"This module implements the o200k-base tokenizer model used by OpenAI's\n`gpt-4o` models.","ref":"AI.Tokenizer.Tokens_o200k_base.html"},{"type":"function","title":"AI.Tokenizer.Tokens_o200k_base.get_merges/0","doc":"","ref":"AI.Tokenizer.Tokens_o200k_base.html#get_merges/0"},{"type":"function","title":"AI.Tokenizer.Tokens_o200k_base.get_pattern/0","doc":"","ref":"AI.Tokenizer.Tokens_o200k_base.html#get_pattern/0"},{"type":"function","title":"AI.Tokenizer.Tokens_o200k_base.get_reverse_vocab/0","doc":"","ref":"AI.Tokenizer.Tokens_o200k_base.html#get_reverse_vocab/0"},{"type":"function","title":"AI.Tokenizer.Tokens_o200k_base.get_special_tokens/0","doc":"","ref":"AI.Tokenizer.Tokens_o200k_base.html#get_special_tokens/0"},{"type":"function","title":"AI.Tokenizer.Tokens_o200k_base.get_vocab/0","doc":"","ref":"AI.Tokenizer.Tokens_o200k_base.html#get_vocab/0"},{"type":"behaviour","title":"AI.Tools","doc":"This module defines the behaviour for tool calls. Defining a new tool\nrequires implementing the `spec/0` and `call/2` functions.\n\nThe `spec/0` function should return a map that describes the tool's\ncapabilities and arguments, using a map to represent the OpenAPI spec.\n\nThe `call/2` function generates the tool call response. It accepts the\nrequesting agent's struct and a map, derived from the parsed JSON provided by\nthe agent, containing the tool call arguments. Note that, because the\narguments are parsed from JSON, the keys will all be strings. Whether those\nare converted to symbols is between the tool implementation and the code it\ncalls. What happens behind closed APIs is none of MY business.","ref":"AI.Tools.html"},{"type":"callback","title":"AI.Tools.call/2","doc":"Calls the tool with the provided arguments and returns the response as an :ok\ntuple.","ref":"AI.Tools.html#c:call/2"},{"type":"function","title":"AI.Tools.perform_tool_call/3","doc":"","ref":"AI.Tools.html#perform_tool_call/3"},{"type":"callback","title":"AI.Tools.spec/0","doc":"Returns the OpenAPI spec for the tool as an elixir map.","ref":"AI.Tools.html#c:spec/0"},{"type":"module","title":"AI.Tools.FileContents","doc":"","ref":"AI.Tools.FileContents.html"},{"type":"module","title":"AI.Tools.FileInfo","doc":"","ref":"AI.Tools.FileInfo.html"},{"type":"module","title":"AI.Tools.GitDiffBranch","doc":"","ref":"AI.Tools.GitDiffBranch.html"},{"type":"module","title":"AI.Tools.GitLog","doc":"","ref":"AI.Tools.GitLog.html"},{"type":"module","title":"AI.Tools.GitPickaxe","doc":"","ref":"AI.Tools.GitPickaxe.html"},{"type":"module","title":"AI.Tools.GitShow","doc":"","ref":"AI.Tools.GitShow.html"},{"type":"module","title":"AI.Tools.ListFiles","doc":"","ref":"AI.Tools.ListFiles.html"},{"type":"module","title":"AI.Tools.Outline","doc":"","ref":"AI.Tools.Outline.html"},{"type":"module","title":"AI.Tools.SaveNotes","doc":"","ref":"AI.Tools.SaveNotes.html"},{"type":"module","title":"AI.Tools.SaveStrategy","doc":"","ref":"AI.Tools.SaveStrategy.html"},{"type":"module","title":"AI.Tools.Search","doc":"","ref":"AI.Tools.Search.html"},{"type":"module","title":"AI.Tools.SearchNotes","doc":"","ref":"AI.Tools.SearchNotes.html"},{"type":"module","title":"AI.Tools.SearchStrategies","doc":"","ref":"AI.Tools.SearchStrategies.html"},{"type":"module","title":"AI.Tools.Spelunker","doc":"","ref":"AI.Tools.Spelunker.html"},{"type":"module","title":"AI.Util","doc":"","ref":"AI.Util.html"},{"type":"function","title":"AI.Util.agent_to_agent_prompt/0","doc":"","ref":"AI.Util.html#agent_to_agent_prompt/0"},{"type":"function","title":"AI.Util.assistant_msg/1","doc":"Creates an assistant message object, representing the assistant's response.","ref":"AI.Util.html#assistant_msg/1"},{"type":"function","title":"AI.Util.assistant_tool_msg/3","doc":"This is the tool call message, which must come immediately before the\n`tool_msg/3` message with the same `tool_call_id` (`id`).","ref":"AI.Util.html#assistant_tool_msg/3"},{"type":"function","title":"AI.Util.cosine_similarity/2","doc":"","ref":"AI.Util.html#cosine_similarity/2"},{"type":"function","title":"AI.Util.system_msg/1","doc":"Creates a system message object, used to define the assistant's behavior for\nthe conversation.","ref":"AI.Util.html#system_msg/1"},{"type":"function","title":"AI.Util.tool_msg/3","doc":"This is the tool outputs message, which must come immediately after the\n`assistant_tool_msg/3` message with the same `tool_call_id` (`id`).","ref":"AI.Util.html#tool_msg/3"},{"type":"function","title":"AI.Util.user_msg/1","doc":"Creates a user message object, representing the user's input prompt.","ref":"AI.Util.html#user_msg/1"},{"type":"behaviour","title":"Cmd","doc":"","ref":"Cmd.html"},{"type":"function","title":"Cmd.default_workers/0","doc":"","ref":"Cmd.html#default_workers/0"},{"type":"callback","title":"Cmd.run/1","doc":"","ref":"Cmd.html#c:run/1"},{"type":"callback","title":"Cmd.spec/0","doc":"","ref":"Cmd.html#c:spec/0"},{"type":"module","title":"Cmd.Ask","doc":"","ref":"Cmd.Ask.html"},{"type":"module","title":"Cmd.Conversations","doc":"","ref":"Cmd.Conversations.html"},{"type":"module","title":"Cmd.Files","doc":"","ref":"Cmd.Files.html"},{"type":"module","title":"Cmd.Index","doc":"","ref":"Cmd.Index.html"},{"type":"function","title":"Cmd.Index.new/2","doc":"","ref":"Cmd.Index.html#new/2"},{"type":"function","title":"Cmd.Index.perform_task/1","doc":"","ref":"Cmd.Index.html#perform_task/1"},{"type":"module","title":"Cmd.Notes","doc":"","ref":"Cmd.Notes.html"},{"type":"module","title":"Cmd.Projects","doc":"","ref":"Cmd.Projects.html"},{"type":"module","title":"Cmd.Search","doc":"","ref":"Cmd.Search.html"},{"type":"module","title":"Cmd.Strategies","doc":"","ref":"Cmd.Strategies.html"},{"type":"module","title":"Cmd.Summary","doc":"","ref":"Cmd.Summary.html"},{"type":"module","title":"Cmd.Torch","doc":"","ref":"Cmd.Torch.html"},{"type":"function","title":"Cmd.Torch.run/1","doc":"Permanently deletes the project from the store.","ref":"Cmd.Torch.html#run/1"},{"type":"module","title":"Cmd.Upgrade","doc":"","ref":"Cmd.Upgrade.html"},{"type":"module","title":"DirStream","doc":"","ref":"DirStream.html"},{"type":"function","title":"DirStream.new/2","doc":"Creates a stream that lazily traverses the given directory recursively.\n\nThe `continue?` callback allows the caller to control traversal. It is called\nwith each directory path before traversing its contents. If it returns\n`false`, the directory is skipped.","ref":"DirStream.html#new/2"},{"type":"function","title":"Parameters: - DirStream.new/2","doc":"- `path` (String): The root directory to traverse.\n  - `continue?` (Function, optional): A function `(String.t() -> boolean)`\n    that determines whether to continue traversing a directory.\n    Defaults to always continuing.","ref":"DirStream.html#new/2-parameters"},{"type":"function","title":"Returns: - DirStream.new/2","doc":"- A `Stream` that yields file paths.","ref":"DirStream.html#new/2-returns"},{"type":"module","title":"Fnord","doc":"Fnord is a code search tool that uses OpenAI's embeddings API to index and\nsearch code files.","ref":"Fnord.html"},{"type":"function","title":"Fnord.configure_logger/0","doc":"","ref":"Fnord.html#configure_logger/0"},{"type":"function","title":"Fnord.main/1","doc":"Main entry point for the application. Parses command line arguments and\ndispatches to the appropriate subcommand.","ref":"Fnord.html#main/1"},{"type":"module","title":"Git","doc":"Module for interacting with git.","ref":"Git.html"},{"type":"function","title":"Git.base_commit/2","doc":"","ref":"Git.html#base_commit/2"},{"type":"function","title":"Git.diff_branch/2","doc":"","ref":"Git.html#diff_branch/2"},{"type":"function","title":"Git.git_diff/1","doc":"","ref":"Git.html#git_diff/1"},{"type":"function","title":"Git.git_log/1","doc":"","ref":"Git.html#git_log/1"},{"type":"function","title":"Git.git_root/0","doc":"","ref":"Git.html#git_root/0"},{"type":"function","title":"Git.is_git_repo?/0","doc":"","ref":"Git.html#is_git_repo?/0"},{"type":"function","title":"Git.is_ignored?/1","doc":"","ref":"Git.html#is_ignored?/1"},{"type":"function","title":"Git.is_ignored?/2","doc":"","ref":"Git.html#is_ignored?/2"},{"type":"function","title":"Git.pickaxe_regex/1","doc":"","ref":"Git.html#pickaxe_regex/1"},{"type":"function","title":"Git.show/1","doc":"","ref":"Git.html#show/1"},{"type":"function","title":"Git.show/2","doc":"","ref":"Git.html#show/2"},{"type":"module","title":"Http","doc":"","ref":"Http.html"},{"type":"function","title":"Http.post_json/4","doc":"","ref":"Http.html#post_json/4"},{"type":"behaviour","title":"Indexer","doc":"This behaviour wraps the AI-powered operations used by `Cmd.Index` to allow\noverrides for testing.","ref":"Indexer.html"},{"type":"callback","title":"Indexer.get_embeddings/2","doc":"","ref":"Indexer.html#c:get_embeddings/2"},{"type":"callback","title":"Indexer.get_outline/3","doc":"","ref":"Indexer.html#c:get_outline/3"},{"type":"callback","title":"Indexer.get_summary/3","doc":"","ref":"Indexer.html#c:get_summary/3"},{"type":"callback","title":"Indexer.new/0","doc":"","ref":"Indexer.html#c:new/0"},{"type":"type","title":"Indexer.completion/0","doc":"","ref":"Indexer.html#t:completion/0"},{"type":"type","title":"Indexer.embeddings/0","doc":"","ref":"Indexer.html#t:embeddings/0"},{"type":"type","title":"Indexer.error/0","doc":"","ref":"Indexer.html#t:error/0"},{"type":"type","title":"Indexer.file_content/0","doc":"","ref":"Indexer.html#t:file_content/0"},{"type":"type","title":"Indexer.file_path/0","doc":"","ref":"Indexer.html#t:file_path/0"},{"type":"type","title":"Indexer.indexer/0","doc":"","ref":"Indexer.html#t:indexer/0"},{"type":"module","title":"Queue","doc":"A module that implements a process pool using a GenServer.","ref":"Queue.html"},{"type":"function","title":"Queue.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Queue.html#child_spec/1"},{"type":"function","title":"Queue.in_progress_jobs/1","doc":"Returns a list of jobs currently being processed.","ref":"Queue.html#in_progress_jobs/1"},{"type":"function","title":"Queue.init/1","doc":"","ref":"Queue.html#init/1"},{"type":"function","title":"Queue.is_idle/1","doc":"Returns true if the queue is idle (no waiters, nothing in the queue), false\notherwise.","ref":"Queue.html#is_idle/1"},{"type":"function","title":"Queue.join/1","doc":"Waits until the queue is empty and all workers have exited.","ref":"Queue.html#join/1"},{"type":"function","title":"Queue.map/2","doc":"Queues an Enum of jobs, executes them, and returns the results in order.","ref":"Queue.html#map/2"},{"type":"function","title":"Queue.queue/2","doc":"Adds a job to the queue and returns a Task.","ref":"Queue.html#queue/2"},{"type":"function","title":"Queue.shutdown/1","doc":"Shuts down the queue, preventing new jobs from being added.","ref":"Queue.html#shutdown/1"},{"type":"function","title":"Queue.start_link/1","doc":"Starts the Queue with the given callback function and maximum number of workers.\nReturns {:ok, pid}","ref":"Queue.html#start_link/1"},{"type":"module","title":"Search","doc":"","ref":"Search.html"},{"type":"function","title":"Search.get_results/1","doc":"","ref":"Search.html#get_results/1"},{"type":"function","title":"Search.new/2","doc":"Creates a new `Search` struct with the given options.","ref":"Search.html#new/2"},{"type":"module","title":"Settings","doc":"","ref":"Settings.html"},{"type":"function","title":"Settings.get/3","doc":"Get a value from the settings store.","ref":"Settings.html#get/3"},{"type":"function","title":"Settings.get_project/1","doc":"","ref":"Settings.html#get_project/1"},{"type":"function","title":"Settings.get_root/1","doc":"","ref":"Settings.html#get_root/1"},{"type":"function","title":"Settings.get_selected_project!/0","doc":"Get the project specified with --project. If the project name is not set, an\nerror will be raised.","ref":"Settings.html#get_selected_project!/0"},{"type":"function","title":"Settings.home/0","doc":"Get the path to the store root directory.","ref":"Settings.html#home/0"},{"type":"function","title":"Settings.new/0","doc":"","ref":"Settings.html#new/0"},{"type":"function","title":"Settings.set/3","doc":"Set a value in the settings store.","ref":"Settings.html#set/3"},{"type":"function","title":"Settings.set_project/2","doc":"","ref":"Settings.html#set_project/2"},{"type":"function","title":"Settings.settings_file/0","doc":"Get the path to the settings file.","ref":"Settings.html#settings_file/0"},{"type":"module","title":"Spinner","doc":"","ref":"Spinner.html"},{"type":"function","title":"Spinner.run/2","doc":"","ref":"Spinner.html#run/2"},{"type":"module","title":"Store","doc":"","ref":"Store.html"},{"type":"function","title":"Store.get_project/0","doc":"","ref":"Store.html#get_project/0"},{"type":"function","title":"Store.get_project/1","doc":"","ref":"Store.html#get_project/1"},{"type":"function","title":"Store.list_conversations/0","doc":"","ref":"Store.html#list_conversations/0"},{"type":"function","title":"Store.list_projects/0","doc":"","ref":"Store.html#list_projects/0"},{"type":"function","title":"Store.store_home/0","doc":"","ref":"Store.html#store_home/0"},{"type":"module","title":"Store.Conversation","doc":"","ref":"Store.Conversation.html"},{"type":"function","title":"Store.Conversation.exists?/1","doc":"","ref":"Store.Conversation.html#exists?/1"},{"type":"function","title":"Store.Conversation.name/1","doc":"","ref":"Store.Conversation.html#name/1"},{"type":"function","title":"Store.Conversation.new/0","doc":"","ref":"Store.Conversation.html#new/0"},{"type":"function","title":"Store.Conversation.new/1","doc":"","ref":"Store.Conversation.html#new/1"},{"type":"function","title":"Store.Conversation.new/2","doc":"","ref":"Store.Conversation.html#new/2"},{"type":"function","title":"Store.Conversation.question/1","doc":"","ref":"Store.Conversation.html#question/1"},{"type":"function","title":"Store.Conversation.read/1","doc":"","ref":"Store.Conversation.html#read/1"},{"type":"function","title":"Store.Conversation.timestamp/1","doc":"","ref":"Store.Conversation.html#timestamp/1"},{"type":"function","title":"Store.Conversation.write/3","doc":"","ref":"Store.Conversation.html#write/3"},{"type":"module","title":"Store.Embeddings","doc":"","ref":"Store.Embeddings.html"},{"type":"module","title":"Store.Entry","doc":"","ref":"Store.Entry.html"},{"type":"function","title":"Store.Entry.create/1","doc":"","ref":"Store.Entry.html#create/1"},{"type":"function","title":"Store.Entry.delete/1","doc":"","ref":"Store.Entry.html#delete/1"},{"type":"function","title":"Store.Entry.embeddings_file_paths/1","doc":"","ref":"Store.Entry.html#embeddings_file_paths/1"},{"type":"function","title":"Store.Entry.exists_in_store?/1","doc":"","ref":"Store.Entry.html#exists_in_store?/1"},{"type":"function","title":"Store.Entry.has_embeddings?/1","doc":"","ref":"Store.Entry.html#has_embeddings?/1"},{"type":"function","title":"Store.Entry.has_metadata?/1","doc":"","ref":"Store.Entry.html#has_metadata?/1"},{"type":"function","title":"Store.Entry.has_outline?/1","doc":"","ref":"Store.Entry.html#has_outline?/1"},{"type":"function","title":"Store.Entry.has_summary?/1","doc":"","ref":"Store.Entry.html#has_summary?/1"},{"type":"function","title":"Store.Entry.hash_is_current?/1","doc":"","ref":"Store.Entry.html#hash_is_current?/1"},{"type":"function","title":"Store.Entry.is_git_ignored?/1","doc":"","ref":"Store.Entry.html#is_git_ignored?/1"},{"type":"function","title":"Store.Entry.is_incomplete?/1","doc":"","ref":"Store.Entry.html#is_incomplete?/1"},{"type":"function","title":"Store.Entry.is_stale?/1","doc":"","ref":"Store.Entry.html#is_stale?/1"},{"type":"function","title":"Store.Entry.metadata_file_path/1","doc":"","ref":"Store.Entry.html#metadata_file_path/1"},{"type":"function","title":"Store.Entry.new_from_entry_path/2","doc":"","ref":"Store.Entry.html#new_from_entry_path/2"},{"type":"function","title":"Store.Entry.new_from_file_path/2","doc":"","ref":"Store.Entry.html#new_from_file_path/2"},{"type":"function","title":"Store.Entry.outline_file_path/1","doc":"","ref":"Store.Entry.html#outline_file_path/1"},{"type":"function","title":"Store.Entry.read/1","doc":"","ref":"Store.Entry.html#read/1"},{"type":"function","title":"Store.Entry.read_embeddings/1","doc":"","ref":"Store.Entry.html#read_embeddings/1"},{"type":"function","title":"Store.Entry.read_metadata/1","doc":"","ref":"Store.Entry.html#read_metadata/1"},{"type":"function","title":"Store.Entry.read_outline/1","doc":"","ref":"Store.Entry.html#read_outline/1"},{"type":"function","title":"Store.Entry.read_source_file/1","doc":"","ref":"Store.Entry.html#read_source_file/1"},{"type":"function","title":"Store.Entry.read_summary/1","doc":"","ref":"Store.Entry.html#read_summary/1"},{"type":"function","title":"Store.Entry.save/4","doc":"","ref":"Store.Entry.html#save/4"},{"type":"function","title":"Store.Entry.save_embeddings/2","doc":"","ref":"Store.Entry.html#save_embeddings/2"},{"type":"function","title":"Store.Entry.save_metadata/1","doc":"","ref":"Store.Entry.html#save_metadata/1"},{"type":"function","title":"Store.Entry.save_outline/2","doc":"","ref":"Store.Entry.html#save_outline/2"},{"type":"function","title":"Store.Entry.save_summary/2","doc":"","ref":"Store.Entry.html#save_summary/2"},{"type":"function","title":"Store.Entry.source_file_exists?/1","doc":"","ref":"Store.Entry.html#source_file_exists?/1"},{"type":"function","title":"Store.Entry.summary_file_path/1","doc":"","ref":"Store.Entry.html#summary_file_path/1"},{"type":"behaviour","title":"Store.EntryFile","doc":"","ref":"Store.EntryFile.html"},{"type":"callback","title":"Store.EntryFile.exists?/1","doc":"","ref":"Store.EntryFile.html#c:exists?/1"},{"type":"callback","title":"Store.EntryFile.new/2","doc":"","ref":"Store.EntryFile.html#c:new/2"},{"type":"callback","title":"Store.EntryFile.read/1","doc":"","ref":"Store.EntryFile.html#c:read/1"},{"type":"callback","title":"Store.EntryFile.store_path/1","doc":"","ref":"Store.EntryFile.html#c:store_path/1"},{"type":"callback","title":"Store.EntryFile.write/2","doc":"","ref":"Store.EntryFile.html#c:write/2"},{"type":"module","title":"Store.Metadata","doc":"","ref":"Store.Metadata.html"},{"type":"module","title":"Store.Note","doc":"","ref":"Store.Note.html"},{"type":"function","title":"Store.Note.exists?/1","doc":"","ref":"Store.Note.html#exists?/1"},{"type":"function","title":"Store.Note.list_notes/1","doc":"","ref":"Store.Note.html#list_notes/1"},{"type":"function","title":"Store.Note.new/1","doc":"","ref":"Store.Note.html#new/1"},{"type":"function","title":"Store.Note.new/2","doc":"","ref":"Store.Note.html#new/2"},{"type":"function","title":"Store.Note.read/1","doc":"","ref":"Store.Note.html#read/1"},{"type":"function","title":"Store.Note.read_embeddings/1","doc":"","ref":"Store.Note.html#read_embeddings/1"},{"type":"function","title":"Store.Note.read_note/1","doc":"","ref":"Store.Note.html#read_note/1"},{"type":"function","title":"Store.Note.reset_project_notes/1","doc":"","ref":"Store.Note.html#reset_project_notes/1"},{"type":"function","title":"Store.Note.search/3","doc":"","ref":"Store.Note.html#search/3"},{"type":"function","title":"Store.Note.write/2","doc":"","ref":"Store.Note.html#write/2"},{"type":"module","title":"Store.Outline","doc":"","ref":"Store.Outline.html"},{"type":"module","title":"Store.Project","doc":"","ref":"Store.Project.html"},{"type":"function","title":"Store.Project.conversations/1","doc":"","ref":"Store.Project.html#conversations/1"},{"type":"function","title":"Store.Project.create/1","doc":"","ref":"Store.Project.html#create/1"},{"type":"function","title":"Store.Project.delete/1","doc":"","ref":"Store.Project.html#delete/1"},{"type":"function","title":"Store.Project.delete_missing_files/1","doc":"","ref":"Store.Project.html#delete_missing_files/1"},{"type":"function","title":"Store.Project.exists_in_store?/1","doc":"","ref":"Store.Project.html#exists_in_store?/1"},{"type":"function","title":"Store.Project.expand_path/2","doc":"","ref":"Store.Project.html#expand_path/2"},{"type":"function","title":"Store.Project.find_path_in_source_root/2","doc":"","ref":"Store.Project.html#find_path_in_source_root/2"},{"type":"function","title":"Store.Project.new/2","doc":"","ref":"Store.Project.html#new/2"},{"type":"function","title":"Store.Project.relative_path/2","doc":"","ref":"Store.Project.html#relative_path/2"},{"type":"function","title":"Store.Project.save_settings/3","doc":"","ref":"Store.Project.html#save_settings/3"},{"type":"function","title":"Store.Project.source_files/1","doc":"","ref":"Store.Project.html#source_files/1"},{"type":"function","title":"Store.Project.stale_source_files/1","doc":"","ref":"Store.Project.html#stale_source_files/1"},{"type":"function","title":"Store.Project.stored_files/1","doc":"","ref":"Store.Project.html#stored_files/1"},{"type":"module","title":"Store.Prompt","doc":"The `ask` subcommand saves useful prompts to the store. Saved prompts are\naccompanied by a title and a list of example questions for which the prompt\nis appropriate.\n\nWhen a prompt is saved, an embedding is generated from it to make the prompt\n(and the questions to which it applies) searchable.\n\nWhenever a prompt is modified or refined, the previous version is archived\nto the prompt's store dir with a version number:\n\n  `<$STORE>/prompts/<$PROMPT_ID>./v<$VERSION>/`\n\nFile structure:\n\n```\n$HOME/\n  -> .fnord/\n    -> prompts/\n      -> <$PROMPT_ID>/\n        -> v1\n          -> title.md\n          -> prompt.md\n          -> questions.md\n          -> embeddings.json\n        -> v2\n          -> title.md\n          -> prompt.md\n          -> questions.md\n          -> embeddings.json\n```\n\nThere are a number of initial prompts that are installed the first time the\nprompt store is searched. These prompts are defined in `data/prompts.yaml`.\nWhen a new version of fnord is installed, the next time the prompt store is\nsearched, the prompts will be updated to the latest versions. \"Default\"\nprompts can be distinguished by using a title slug for its id, rather than a\nUUID.","ref":"Store.Prompt.html"},{"type":"function","title":"Store.Prompt.exists?/1","doc":"","ref":"Store.Prompt.html#exists?/1"},{"type":"function","title":"Store.Prompt.install_initial_strategies/0","doc":"","ref":"Store.Prompt.html#install_initial_strategies/0"},{"type":"function","title":"Store.Prompt.list_prompts/0","doc":"","ref":"Store.Prompt.html#list_prompts/0"},{"type":"function","title":"Store.Prompt.list_versions/1","doc":"","ref":"Store.Prompt.html#list_versions/1"},{"type":"function","title":"Store.Prompt.new/0","doc":"","ref":"Store.Prompt.html#new/0"},{"type":"function","title":"Store.Prompt.new/1","doc":"","ref":"Store.Prompt.html#new/1"},{"type":"function","title":"Store.Prompt.read/1","doc":"","ref":"Store.Prompt.html#read/1"},{"type":"function","title":"Store.Prompt.read/2","doc":"","ref":"Store.Prompt.html#read/2"},{"type":"function","title":"Store.Prompt.read_embeddings/1","doc":"","ref":"Store.Prompt.html#read_embeddings/1"},{"type":"function","title":"Store.Prompt.read_embeddings/2","doc":"","ref":"Store.Prompt.html#read_embeddings/2"},{"type":"function","title":"Store.Prompt.read_prompt/1","doc":"","ref":"Store.Prompt.html#read_prompt/1"},{"type":"function","title":"Store.Prompt.read_prompt/2","doc":"","ref":"Store.Prompt.html#read_prompt/2"},{"type":"function","title":"Store.Prompt.read_questions/1","doc":"","ref":"Store.Prompt.html#read_questions/1"},{"type":"function","title":"Store.Prompt.read_questions/2","doc":"","ref":"Store.Prompt.html#read_questions/2"},{"type":"function","title":"Store.Prompt.read_title/1","doc":"","ref":"Store.Prompt.html#read_title/1"},{"type":"function","title":"Store.Prompt.read_title/2","doc":"","ref":"Store.Prompt.html#read_title/2"},{"type":"function","title":"Store.Prompt.search/2","doc":"","ref":"Store.Prompt.html#search/2"},{"type":"function","title":"Store.Prompt.version/1","doc":"","ref":"Store.Prompt.html#version/1"},{"type":"function","title":"Store.Prompt.write/4","doc":"","ref":"Store.Prompt.html#write/4"},{"type":"module","title":"Store.Summary","doc":"","ref":"Store.Summary.html"},{"type":"module","title":"UI","doc":"","ref":"UI.html"},{"type":"function","title":"UI.begin_step/2","doc":"","ref":"UI.html#begin_step/2"},{"type":"function","title":"UI.confirm/1","doc":"","ref":"UI.html#confirm/1"},{"type":"function","title":"UI.confirm/2","doc":"","ref":"UI.html#confirm/2"},{"type":"function","title":"UI.debug/1","doc":"","ref":"UI.html#debug/1"},{"type":"function","title":"UI.debug/2","doc":"","ref":"UI.html#debug/2"},{"type":"function","title":"UI.end_step/2","doc":"","ref":"UI.html#end_step/2"},{"type":"function","title":"UI.error/1","doc":"","ref":"UI.html#error/1"},{"type":"function","title":"UI.error/2","doc":"","ref":"UI.html#error/2"},{"type":"function","title":"UI.flush/0","doc":"","ref":"UI.html#flush/0"},{"type":"function","title":"UI.info/1","doc":"","ref":"UI.html#info/1"},{"type":"function","title":"UI.info/2","doc":"","ref":"UI.html#info/2"},{"type":"function","title":"UI.inspect/2","doc":"","ref":"UI.html#inspect/2"},{"type":"function","title":"UI.report_step/1","doc":"","ref":"UI.html#report_step/1"},{"type":"function","title":"UI.report_step/2","doc":"","ref":"UI.html#report_step/2"},{"type":"function","title":"UI.warn/1","doc":"","ref":"UI.html#warn/1"},{"type":"function","title":"UI.warn/2","doc":"","ref":"UI.html#warn/2"},{"type":"extras","title":"Fnord","doc":"# Fnord\n\n[![Tests | Dialyzer](https://github.com/sysread/fnord/actions/workflows/run-tests.yml/badge.svg)](https://github.com/sysread/fnord/actions/workflows/run-tests.yml)\n\nFnord is a command line tool that uses multiple AI-powered agents and tools to\nprovide a conversational interface to your codebase, notes, and other\n(non-binary) files.","ref":"readme.html"},{"type":"extras","title":"Features - Fnord","doc":"- Code base search\n- Graph search and pathfinding\n- On-demand playbooks assembled from documentation and code\n- Troubleshooting and debugging\n- Git archaeology\n- Learns about your project(s) over time\n- Improves its research capabilities with each interaction","ref":"readme.html#features"},{"type":"extras","title":"Installation - Fnord","doc":"1. Install `elixir` if necessary:\n```bash\n# MacOS\nbrew install elixir\n\n# Debian-based\nsudo apt-get install elixir\n```\n\n2. Add the mix escript path to your shell's PATH:\n```bash\necho 'export PATH=\"$HOME/.mix/escripts:$PATH\"' >> ~/.bashrc\nsource ~/.bashrc\n```\n\n3. Install the script:\n```bash\nmix escript.install github sysread/fnord\n```\n\nUse the same command to reinstall. It will offer to overwrite the existing\ninstallation.\n\n4. Set `OPENAI_API_KEY`\n\nSet this in your shell environment to the OpenAI project key you wish to use\nfor this tool. You can create a new project and get a key\n[here](https://platform.openai.com/api-keys).","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Fnord","doc":"","ref":"readme.html#usage"},{"type":"extras","title":"Index - Fnord","doc":"The first step is to index your project. This will scan all files in the\nproject directory and create a searchable database.\n\nThe initial index, especially on a large codebase, can will take a while.\nSubsequent runs will be faster, re-indexing only those files which have changed\nsince they were last indexed.\n\nThe `--dir` option is required only for the initial indexing. Subsequent\nindexing will use the directory specified in the initial index.\n\n```bash\nfnord index --project foo --dir /path/to/foo\n```\n\nYou can **reindex** the project, forcing it to reindex all files.\n\n```bash\nfnord index -p foo -d /path/to/foo --reindex\n```\n\n`fnord` learns about your project over time, so every now and then it's a good\nidea to **consolidate** the notes it has taken.\n\n```bash\nfnord index -p foo --defrag-notes\n```\n\nYou can also watch the project for changes and reindex them as they happen\nusing [watchman](https://github.com/facebook/watchman). Just be sure to use\n`--quiet` to suppress interactive output.\n\n```bash\nwatchman-make -p '**/*' --settle 5 --run \"fnord index --project $project --dir $project_root --quiet\"\n```\n\n...or use the `fnord-watch` script in the [tools directory on\nGitHub](https://github.com/sysread/fnord/blob/main/tools/fnord-watch).\n\n```bash\nfnord-watch -p foo -d /path/to/foo\n```","ref":"readme.html#index"},{"type":"extras","title":"Search - Fnord","doc":"Search for files in the project that match a query.\n\n```bash\nfnord search -p foo -q \"some search query\"\n```\n\nIf you want more detail about each file matched:\n\n```bash\nfnord search -p foo -q \"some search query\" --detail\n```","ref":"readme.html#search"},{"type":"extras","title":"Ask - Fnord","doc":"Ask the AI assistant to answer questions about your project.\n\n```bash\nfnord ask -p foo -q \"how do you run the tests for this project?\"\n\n# Pipe output to `glow` to render markdown\nfnord ask -p foo -q \"summarize the dependencies of this project\" | glow\n\n# Reveal tool calls and research steps\nLOGGER_LEVEL=debug fnord ask -p foo -q \"summarize the dependencies of this project\" | glow\n```","ref":"readme.html#ask"},{"type":"extras","title":"Miscellaneous - Fnord","doc":"- **List projects:** `fnord projects`\n- **List files in a project:** `fnord files -p foo`\n- **List learned insights and inferences:** `fnord notes -p foo`\n- **List learned research strategies:** `fnord strategies`\n- **Show the AI-generated summary of a file:** `fnord summary -p foo -f bar.ext`\n- **Delete a project:** `fnord delete -p foo`\n- **Show conversations:** `fnord conversations -p foo -q`\n\nNote that deleting a project only deletes from the index, not the actual files.","ref":"readme.html#miscellaneous"},{"type":"extras","title":"Tool usage - Fnord","doc":"Internally, the `ask` command uses the OpenAI chat completions API to generate\na response, implementing a function tool to allow the assistant to query the\ndatabase for information.\n\n`fnord` can be used to implement a similar tool for your own projects. While\nthe `ask` command severely limits the parameters that the assistant may utilize\n(`query` only, with `project` being provided by the user's invocation of the\ncommand), the following syntax includes the full set of parameters available\nfor the `search` command.\n\n```json\n{\n  \"name\": \"search_tool\",\n  \"description\": \"Searches for matching files and their contents in a project.\",\n  \"parameters\": {\n    \"type\": \"object\",\n    \"properties\": {\n      \"project\": {\n        \"type\": \"string\",\n        \"description\": \"Project name for the search.\"\n      },\n      \"query\": {\n        \"type\": \"string\",\n        \"description\": \"The search query string.\"\n      },\n      \"detail\": {\n        \"type\": \"boolean\",\n        \"description\": \"Include AI-generated file summary if set to true.\"\n      },\n      \"limit\": {\n        \"type\": \"integer\",\n        \"description\": \"Limit the number of results (default: 10).\"\n      },\n      \"workers\": {\n        \"type\": \"integer\",\n        \"description\": \"Number of concurrent workers to use for the search.\"\n      }\n    },\n    \"required\": [\"project\", \"query\"]\n  }\n}\n```\n\n# TODO\n- ask: report how old the index is\n- index: option to verify and consolidate notes","ref":"readme.html#tool-usage"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.35.1"}}